﻿// Programm1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <complex>
#include <math.h>
using namespace std;



int main()
{
	setlocale(LC_ALL, "Russian");
	//действующее значение напряжения- Пример однострочного комментария
	double E;
	/*значение частоты источника напряжения
	и начальной фазы.- Пример однострочного комментария*/
	double f, ksi;
	double R1, L1, C1, C2;//Параметры нагрузки
	cout << "Введите значение R1 в Ом" << endl;
	cin >> R1;
	cout << "Введите значение L1 в мГн" << endl;
	cin >> L1;
	cout << "Введите значение C1 в мкФ" << endl;
	cin >> C1;
	cout << "Введите значение C2 в мкФ" << endl;
	cin >> C2;
	cout << "Введите действующее значение ЭДС" << endl;
	cin >> E;
	cout << "Введите значение частоты в Гц" << endl;
	cin >> f;
	cout << "Введите значение начальной фазы напряжения в градусах" << endl;
	cin >> ksi;
	complex<double> Es, Xl1, Xc1, Xc2;
	double w = 2 * 3.14 * f;

	// расчёт комплесного ЭДС
	Es.real(E * cos(ksi * 3.14 / 180)); // действительная часть
	Es.imag(E * sin(ksi * 3.14 / 180)); // мнимая часть

	// расчёт сопротивления катушек L1 и L2
	Xl1.real(0); // действительная часть
	Xl1.imag(w * L1 / 1000.0); // мнимая часть

	// расчёт сопротивления конденсаторов C1 и C2
	if (w != 0)// != - означает "неравно"
	{
		Xc1.real(0); // действительная часть 
		Xc1.imag(1000000.0 / (w * C1)); // мнимая часть
	}
	else
	{
		Xc1.real(0); // действительная часть 
		Xc1.imag(-1.0); // сигнализирует разрыв
	}

	if (w != 0)
	{
		Xc2.real(0);
		Xc2.imag(1000000.0 / (w * C2)); // мнимая часть
	}
	else
	{
		Xc2.real(0);
		Xc2.imag(-1.0); // сигнализирует разрыв
	}

	complex<double> Z1;
	if (Xc2.imag() == -1)
	{
		Z1.imag(-1);
		Z1.real(-1);
	}
	else
	{
		Z1 = (Xc2 * R1) / (Xc2 + R1);
	}

	complex<double> Z2;
	if (Z1.imag() == -1)
	{
		Z2 = Z1;
	}
	else
	{
		Z2 = Xl1 + Z1;
	}

	complex<double> Z;
	if (Xc1.imag() == -1)
	{
		Z = Xc1;
	}
	else
	{
		Z = (Xc1 * Z2) / (Xc1 + Z2);
	}

	// расчёт полного тока
	complex<double> I = Es / Z;
	// расчёт тока через ветвь с конденсатором C1
	complex<double> Ic1;
	if (Xc1.imag() != -1)
	{
		Ic1 = Es / Xc1;
	}
	else
	{
		Ic1 = 0;
	}
	// расчёт тока через ветвь с сопротивлением Z3
	complex<double> Iz2;
	if (Z2.imag() != -1)
	{
		Iz2 = Es / Z2;
	}
	else
	{
		Iz2 = 0;
	}
	complex<double> Il1 = Iz2;
	// расчёт напряжения между узлами bc
	complex<double> Ubc = Es - Xl1 * Il1;
	// расчёт тока через ветвь с Z1
	complex<double> Iz1;
	if (Z1.imag() != -1)
	{
		Iz1 = Ubc / Z1;
	}
	else
	{
		Iz1 = 0;
	}
	// расчёт тока через ветвь
	// с резистором R1 и ёмкостью C2
	complex<double> Ir1 = Iz1;
	complex<double> Ic2 = Iz1;

	// расчёт напряжения на C1
	complex<double> Uc1 = Ic1 * Xc1;// с учётом схемы допустимо Ucq=Es
	// расчёт напряжения на L1
	complex<double> Ul1 = Il1 * Xl1;
	// расчёт напряжения на C2
	complex<double> Uc2 = Ic2 * Xc2;
	// расчёт напряжения на R1
	complex<double> Ur1 = Ir1 * R1;

	//расчёт мощности потребителей от источника 
	complex<double> Ssrc = Es * conj(I);
	// расчёт суммарной мощности приёмников
	complex<double> Spr = Xc1 * Ic1 * conj(Ic1) +
		Xl1 * Il1 * conj(Il1) +
		Xc2 * Ic2 * conj(Ic2) +
		R1 * Ir1 * conj(Ir1);
	double cos_fi = Ssrc.real() / abs(Ssrc);

	double eps = 0.0001;//переменная определяющая точность
	if ((Ssrc.real() - Spr.real() < eps) &&
		(Ssrc.imag() - Spr.imag() < eps))
	{
		cout << "Расчёт верный" << endl;
	}
	else
	{
		cout << "Расчёт неверный" << endl;
	}

	cout << "мощность источника= " << abs(Ssrc) << " BA" << endl;
	cout << "мощность приёмников= " << abs(Spr) << " BA" << endl;
	cout << "Коэффициент мощности= " << cos_fi << endl;
	cout << "Напряжение на R1= " << abs(Ur1) << " B" << endl;
	cout << "Напряжение на C1= " << abs(Uc1) << " B" << endl;
	cout << "Напряжение на C2= " << abs(Uc2) << " B" << endl;
	cout << "Напряжение на L1= " << abs(Ul1) << " B" << endl;
	cout << "Ток через ветвь с источником ЭДС= " << abs(I) << " A" << endl;
	cout << "Ток через ветвь с R1 и  C2= " << abs(Iz1) << " A" << endl;
	cout << "Ток через ветвь с L1= " << abs(Il1) << " A" << endl;
	cout << "Ток через ветвь с С1= " << abs(Ic1) << " A" << endl;

	system("pause");
	return 0;
}